/*jshint esnext:true*/

//create a schedule for the selected event
//types = download, email, edit, open
function createSchedule(event_id, type){
  
  var descendants = app.pages.EventDetail.descendants;
  
  var editSpinner = descendants.editSpinner;
  var editButton = descendants.editButton;
  
  var emailSpinner = descendants.emailSpinner;
  var emailButton = descendants.emailButton;
  
  var openSpinner = descendants.openSpinner;
  var openButton = descendants.openButton;
  
  var downloadSpinner = descendants.downloadSpinner;
  var downloadButton = descendants.downloadButton;
  
  editButton.visible = true;
  emailButton.visible = true;
  downloadButton.visible = true;
  openButton.visible = true;

  editButton.enabled = false;
  emailButton.enabled = false;
  downloadButton.enabled = false;
  openButton.enabled = false;
  
  var scheduleType;
  
  if(type === 'edit'){
      editSpinner.visible = true;
      editButton.visible = false;
      scheduleType = 'doc';
    
  }else if(type === 'download'){
      downloadSpinner.visible = true;
      downloadButton.visible = false;
      scheduleType = 'pdf';
    
  }else if(type === 'email'){
      emailSpinner.visible = true;
      emailButton.visible = false;
      scheduleType = 'email';
    
  }else if(type === 'open'){
      openSpinner.visible = true;
      openButton.visible = false;
      scheduleType = 'pdf';
  }
  
  var parameters = {type: type, event_name: app.pages.EventDetail.datasource.item.Name};

      google.script.run
        .withUserObject(parameters)
        .withSuccessHandler(result => {
        
         var type = parameters.type;
         var event_name = parameters.event_name;
        
         editButton.visible = editButton.enabled = true;
         emailButton.visible = emailButton.enabled = true;
         downloadButton.visible = downloadButton.enabled = true;
         openButton.visible = openButton.enabled = true;
        
         editSpinner.visible = false;
         emailSpinner.visible = false;
         downloadSpinner.visible = false;
         openSpinner.visible = false;
        
         var url;
         var filename;
        
         if(type === 'download' || type === 'open'){
            let bytes = new Uint8Array(result.length);
            for (var i = 0; i < result.length; i++) {
               bytes[i] = result[i];
            }
            var blob = new Blob([bytes], {'type': 'application/pdf'});
            url = URL.createObjectURL(blob);
            filename = event_name + ' Schedule.pdf';
           
         }else if(type === 'edit'){
            url = result;
         }
        
         if(type !== 'email'){
             var a = document.createElement('a');
             document.body.appendChild(a);
             a.style = "display:none;";
             a.href = url;
             a.target = '_blank';
           
             if(type === 'open'){
               a.view = filename;
               
             }else if(type === 'download'){
               a.download = filename; 
             }

             a.click();
         }

  })
    .createSchedulePDF(event_id, scheduleType);

}
