//check if there is any data in the database
function checkForData(){
   var tables = ['Category','Company','Person','EmailTemplate','Vendor','Event','VendorContact','EmailLog','Invitee','Role'];
   for(var i = 0; i < tables.length; i++){
    var table = tables[i];
    if(app.models[table].newQuery().run().length > 0){
      return 'Already Loaded';
    }
  }
   return 'Load Required';
}

//load data from the server
//this is configured to only run when every table is empty
function loadInitialData(){
  var baseUrl = 'https://www.supportgroup.com/AppMaker/';
  var tables = ['Category','Company','Person','EmailTemplate','Vendor','Event','VendorContact','EmailLog','Invitee','Role'];
  var records = [];

  for(var i = 0; i < tables.length; i++){
    var table = tables[i];
    var csvUrl = baseUrl + table + '.csv';
    var csvContent;
    try{
      csvContent = UrlFetchApp.fetch(csvUrl).getContentText();
    }catch(error){
      console.log(table + ':' + error);
      csvContent = null;
    }
    if(typeof csvContent !== 'undefined' && csvContent !== null){
      var csvData = Utilities.parseCsv(csvContent);
      var fields = csvData[0];

      for(var row = 1; row < csvData.length; row++){
        var rowData = csvData[row];
        var record = app.models[table].newRecord();
        for(var col = 0; col < fields.length; col++){
          var field = fields[col];
          var type = app.metadata.models[table].fields[field].type;
          var data = rowData[col];
          if(data !== null && data !== '\\N'){
            if(type === 'String'){
              data = data.replace(/(?:\\[n])+/g, '\n');
            }else if(type === 'Number'){
              data = Number(data);
            }else if(type === 'Date'){
              var date = new Date();
              var dateArray = data.replace(/[: ]/g,'-').split('-');
              date.setDate(dateArray[2]);
              date.setFullYear(dateArray[0]);
              date.setMonth(dateArray[1]-1);
              date.setHours(dateArray[3]);
              date.setMinutes(dateArray[4]);
              date.setSeconds(dateArray[5]);
              data = date;
            }else if(type === 'Boolean'){
              data = Boolean(Number(data));
            }
            record[field] = data;
          }
        }
        records.push(record);
      }
    }
  }
  app.saveRecords(records);
}







